

/**
PRUEBA_3 termometro  
******************************************************************************
*/

/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "stm32f1xx_hal.h"
#include "LCD_2x16.h"
#include "adc.h"
#include "gpio.h"

LCD_HandleTypeDef lcd;
uint32_t adc1=0; 


void SystemClock_Config(void);
void temp_celsius(void);
void temp_fahrenheit (void);


int main(void)
{

  HAL_Init();
  SystemClock_Config();
  MX_GPIO_Init();
  MX_ADC1_Init();
	
/* lcd configuration */
	
  lcd.RS.Port = GPIOC;      
  lcd.RS.Pin = GPIO_PIN_14;
  
  lcd.EN.Port = GPIOC;
  lcd.EN.Pin = GPIO_PIN_15;
  
  lcd.DB4.Port = GPIOA;
  lcd.DB4.Pin = GPIO_PIN_4;
  
  lcd.DB5.Port = GPIOA;
  lcd.DB5.Pin = GPIO_PIN_5;
  
  lcd.DB6.Port = GPIOA;
  lcd.DB6.Pin = GPIO_PIN_6;
  
  lcd.DB7.Port = GPIOA;
  lcd.DB7.Pin = GPIO_PIN_7;
	
  HAL_Delay(100);
  LCD_sendCmd(&lcd, 0x33); // Initialize controller
  LCD_sendCmd(&lcd, 0x32); // Set 4-bit mode
  LCD_sendCmd(&lcd, 0x28); // 4 bit, 2 line, 5x7
  LCD_sendCmd(&lcd, 0x06); // Cursor direction -> right
  LCD_sendCmd(&lcd, 0x0C); // Display on, cursor off
  LCD_sendCmd(&lcd, 0x01); // Clear display
  HAL_Delay(100);
	
 int line = 0, position = 2;
 LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
 LCD_TEXT(&lcd,"TERMOMETRO");

  /* USER CODE BEGIN WHILE */
  while (1)
  {
  /* USER CODE END WHILE */
		 HAL_ADC_Start(&hadc1);
	   HAL_ADC_PollForConversion(&hadc1, 100);
	   adc1 = HAL_ADC_GetValue(&hadc1);
     HAL_Delay(10);
		 temp_celsius();
		 temp_fahrenheit();
     HAL_Delay(1000);	
	   HAL_ADC_Stop (&hadc1);
  }

}

void temp_celsius(void){
 
float celsius;	
char x[1];
int line = 0, position = 0;	
	
	   celsius=adc1*0.080586; /* (3.3/4095)*(100) = 0.080586 */
		 line = 1, position = 0; 
     LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
	   LCD_FLOAT(&lcd,celsius);
		 line = 1, position = 5; 
     LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
		 x[0]=223;	/*()	*/
     LCD_TEXT(&lcd,x);
		 line = 1, position = 6; 
     LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
     LCD_TEXT(&lcd,"C");
	
}

void temp_fahrenheit (void){
 float fahrenheit;	
 char x[1];
 int line = 0, position = 0;
	
	   fahrenheit= adc1*0.080586; /* (3.3/4095)*(100) = 0.080586 */
		 fahrenheit=(fahrenheit*1.8)+32;
		 line = 1, position = 8; 
     LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
	   LCD_FLOAT(&lcd,fahrenheit);
		 line = 1, position = 13; 
     LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
		 x[0]=223;	/*()	*/
     LCD_TEXT(&lcd,x);
		 line = 1, position = 14; 
     LCD_sendCmd(&lcd, 0x80 | (line*0x40 + position));
     LCD_TEXT(&lcd,"F");
	
}	
/*System Clock Configuration*/
void SystemClock_Config(void)
{

  RCC_OscInitTypeDef RCC_OscInitStruct;
  RCC_ClkInitTypeDef RCC_ClkInitStruct;
  RCC_PeriphCLKInitTypeDef PeriphClkInit;

    /**Initializes the CPU, AHB and APB busses clocks 
    */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

    /**Initializes the CPU, AHB and APB busses clocks 
    */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_ADC;
  PeriphClkInit.AdcClockSelection = RCC_ADCPCLK2_DIV6;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    _Error_Handler(__FILE__, __LINE__);
  }

    /**Configure the Systick interrupt time 
    */
  HAL_SYSTICK_Config(HAL_RCC_GetHCLKFreq()/1000);

    /**Configure the Systick 
    */
  HAL_SYSTICK_CLKSourceConfig(SYSTICK_CLKSOURCE_HCLK);

  /* SysTick_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(SysTick_IRQn, 0, 0);
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @param  None
  * @retval None
  */
void _Error_Handler(char * file, int line)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  while(1) 
  {
  }
  /* USER CODE END Error_Handler_Debug */ 
}

#ifdef USE_FULL_ASSERT

/**
   * @brief Reports the name of the source file and the source line number
   * where the assert_param error has occurred.
   * @param file: pointer to the source file name
   * @param line: assert_param error line source number
   * @retval None
   */
void assert_failed(uint8_t* file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
    ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */

}

#endif

/**
  * @}
  */ 

/**
  * @}
*/ 

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
